#import "BMIController.h"

@implementation BMIController

- (void)awakeFromNib
{
	NSNotificationCenter	*aCenter=[NSNotificationCenter defaultCenter];
    [aCenter addObserver:NSApp
                selector:@selector(terminate:)
                name:@"NSWindowWillCloseNotification"
                object:bmiWindow];

    [aCenter addObserver:self
                selector:@selector(applicationWillTerminate:)
                name:@"NSApplicationWillTerminateNotification"
                object:NSApp];
}

- (void)applicationWillTerminate:(NSNotification *)pNotification
{
	NSLog(@"Haaku sita!");
}

- (IBAction)calcBMI:(id)sender
{
	float	aBMIValue;
	//関数で計算
	aBMIValue = calculateBMI([heightField floatValue], [weightField floatValue]);
	//引き数を渡さないでメソッドで計算
	aBMIValue=[self calculateBMI];
	//引き数を渡してメソッドで計算
	aBMIValue=[self calcBMIFromHeight:[heightField floatValue] andWeight:[weightField floatValue]];

	//値をテキストフィールドに表示
	[bmiField setFloatValue: aBMIValue];
}

- (IBAction)calcWeight:(id)sender
{
	[weightField setFloatValue:calculateWeight([heightField floatValue], [bmiField floatValue])];
}


//体重を逆算する
float calculateWeight(float pHeight, float pBMI)
{
	return pBMI*(pHeight/100)*(pHeight/100);
}

//BMIの計算
//関数で計算する
float calculateBMI(float pHeight, float pWeight)
{
	return pWeight/(pHeight/100)/(pHeight/100);
}

//引き数を渡さないでメソッドで計算する
- (float)calculateBMI
{
	return [weightField floatValue]/([heightField floatValue]/100)/([heightField floatValue]/100);
}

//引き数を渡してメソッドで計算する
- (float)calcBMIFromHeight:(float)pHeight andWeight:(float)pWeight
{
	return pWeight/(pHeight/100)/(pHeight/100);
}
@end
